﻿local DD = AceLibrary("Dewdrop-2.0")

local L = AceLibrary("AceLocale-2.2"):new("Whats")

Whats.Menu = { 
	type = "group", 
	args = {
		Open = {
			name = L["Open"],
			order = 1,
			type = "execute",
			desc = L["Display Whats Menu"],
			func = function() self:OnClick() DD:Close() end,
		},
		Search = {
			name = L["Search"],
			order = 2,
			type = "text",
			usage = L["Item ID or Item name"],
			desc = L["Searching Items"],
			get = false,
			set = function(t) self.Search(t) end
		},
		Appearance = {
			type = "group",
			name = L["Appearance"],
			order = 2,
			desc = L["Set Whats Displey Option."],
			args = {
				Border = {
					type = "text",
					name = L["Border"],
					desc = L["Set Border"],
					validate = SharedMedia:List('border'),
					get = function() return self.db.profile.border end,
					set = function(b) 
						self.db.profile.border = b Whats:ApplySetting()
						Whats:ApplySetting()
					end
				},
				Width = {
					type = "group",
					name = L["Width"],
					desc = L["Set Width of Whats menu and Whats Item button."],
					args = {
						Menu = {
							type = "range",
							name = L["Menu"],
							desc = L["Set width of Whats menu."],
							min = 100,
							max = 200,
							step = 10,
							get = function() return self.db.profile.menuWidth end,
							set = function(r) 
								self.db.profile.menuWidth = r 
								Whats:ApplySetting()
							end
						},
						Button = {
							type = "range",
							name = L["Button"],
							desc = L["Set width of Whats item button."],
							min = 128,
							max = 188,
							step = 10,
							get = function() return self.db.profile.buttonWidth end,
							set = function(r) 
								self.db.profile.buttonWidth = r 
								Whats:ApplySetting()
							end
						}
					}
				},
				Color = {
					type = "group",
					name = L["Color"],
					desc = L["Set color of Whats elements"],
					args = {
						Checked = {
							type = "color",
							name = L["Chached Item"],
							desc = L["Set color of chached item button."],
							get = function() return self.db.profile.Ccolor.r, self.db.profile.Ccolor.g, self.db.profile.Ccolor.b, self.db.profile.Ccolor.a end,
							set = function(r, g, b, a) self.db.profile.Ccolor.r, self.db.profile.Ccolor.g, self.db.profile.Ccolor.b, self.db.profile.Ccolor.a = r, g, b, a end,
						},
						Unchecked = {
							type = "color",
							name = L["Unchached Item"],
							desc = L["Set color of unchached item button"],
							get = function() return self.db.profile.Ucolor.r, self.db.profile.Ucolor.g, self.db.profile.Ucolor.b, self.db.profile.Ucolor.a end,
							set = function(r, g, b, a) self.db.profile.Ucolor.r, self.db.profile.Ucolor.g, self.db.profile.Ucolor.b, self.db.profile.Ucolor.a = r, g, b, a end,
						},
						Nochecked = {
							type = "color",
							name = L["No chached Item"],
							desc = L["Set color of no chached item button."],
							get = function() return self.db.profile.Ncolor.r, self.db.profile.Ncolor.g, self.db.profile.Ncolor.b, self.db.profile.Ncolor.a end,
							set = function(r, g, b, a) self.db.profile.Ncolor.r, self.db.profile.Ncolor.g, self.db.profile.Ncolor.b, self.db.profile.Ncolor.a = r, g, b, a end,
						},
						Menu = {
							type = "color",
							name = L["Menu"],
							desc = L["Set color of menu."],
							get = function() return self.db.profile.Mcolor.r, self.db.profile.Mcolor.g, self.db.profile.Mcolor.b, self.db.profile.Mcolor.a end,
							set = function(r, g, b, a) self.db.profile.Mcolor.r, self.db.profile.Mcolor.g, self.db.profile.Mcolor.b, self.db.profile.Mcolor.a = r, g, b, a end,
						}
					}
				},
				Texture = {
					name = L["Texture"],
					type = "text",
					desc = L["Set texture."],
					validate = SharedMedia:List('background'),
					get = function() return self.db.profile.texture end,
					set = function(t) 
						self.db.profile.texture = t 
						Whats:ApplySetting()
					end
				},
				Font = {
					name = L["Font"],
					type = "text",
					desc = L["Set font."],
					validate = SharedMedia:List('font'),
					get = function() return self.db.profile.font end,
					set = function(f) 
						self.db.profile.font = f 
						Whats:ApplySetting()
					end
				},
				Growth = {
					name = L["Direction"],
					type = "text",
					desc = L["Set growth direction"],
					validate = {["U"] = L["Up"], ["D"] = L["Down"], ["L"] = L["Left"], ["R"] = L["Right"]},
					get = function() return self.db.profile.growth end,
					set = function(g) 
						self.db.profile.growth = g 
						Whats:ApplySetting()
					end

				},
				Column = {
					name = L["Column"],
					type = "range",
					desc = L["Set column of item button"],
					min = 2,
					max = 4,
					step = 1,
					get = function() return self.db.profile.column end,
					set = function(c) 
						self.db.profile.column = c 
						Whats:ApplySetting()
					end
				}
			}
		}
	}
}
